//% color="#fa9b4d" iconWidth=50 iconHeight=40
namespace SKImage{

    //% block="初始化HOG特征库" blockType="command"
    export function Sklearn_init(parameter: any, block: any) {
        Generator.addImport("from skimage.feature import hog");

    }

    //% block="对象名[NM2]将图片[NM1]转化为多通道HOG特征图 " blockType="command"
    //% NM1.shadow="normal"   NM1.defl="img"
    //% NM2.shadow="normal"   NM2.defl="img"
    export function drawhog1(parameter: any, block: any){
        let nm1 = parameter.NM1.code
        let nm2 = parameter.NM2.code
        Generator.addCode(`fd, ${nm2} = hog(${nm1} , orientations=9, pixels_per_cell=(8, 8), cells_per_block=(2, 2), visualize=True, multichannel=True)`)
    }

    //% block="对象名[FD1]获取图片[IMG1]转化为单通道HOG特征 " blockType="command"
    //% FD1.shadow="normal"   FD1.defl="fd"
    //% IMG1.shadow="normal"   IMG1.defl="img"
    export function drawhog2(parameter: any, block: any){
        let fd1 = parameter.FD1.code
        let img1 = parameter.IMG1.code
        Generator.addCode(`${fd1} = hog(${img1} , orientations=9, pixels_per_cell=(8, 8), cells_per_block=(2, 2), visualize=False)`)
    }

    //% block="对象名[NM4]增强[NM3]的HOG特征" blockType="command"
    //% NM3.shadow="normal"   NM3.defl="image"
    //% NM4.shadow="normal"   NM4.defl="image"
    export function enhance(parameter: any, block: any){ 
        let nm3 = parameter.NM3.code
        let nm4 = parameter.NM4.code
        Generator.addImport("from skimage import exposure");
        Generator.addImport("from skimage.util import img_as_ubyte");
        Generator.addCode(`hog_rgb_rescaled = exposure.rescale_intensity(${nm3}, in_range=(0, 10)) `);
        Generator.addCode(`${nm4} = img_as_ubyte(hog_rgb_rescaled)`);
   
   }

    //% block="对象名[NM8]将数组[NM7]转化成图像" blockType="command"
    //% NM7.shadow="normal"   NM7.defl="image"
    //% NM8.shadow="normal"   NM8.defl="image"
    export function fromarray(parameter: any, block: any){ 
        let nm7 = parameter.NM7.code
        let nm8 = parameter.NM8.code
        Generator.addImport("from PIL import Image");
        Generator.addCode(`${nm8} = Image.fromarray(${nm7})`)
   
   }
}